%define anolis_release 2
%undefine _package_note_flags
%undefine _package_note_file
%ifarch sw_64
%global debug_package %{nil}
%define __os_install_post %{nil}
%endif

Name:           ocaml-findlib
Version:        1.9.6
Release:        %{anolis_release}%{?dist}
Summary:        Objective CAML package manager and build helper
License:        MIT
URL:            http://projects.camlcity.org/projects/findlib.html
Source0:        http://download.camlcity.org/download/findlib-%{version}.tar.gz

BuildRequires:  ocaml >= 4.02.0
BuildRequires:  ocaml-labltk-devel
BuildRequires:  ocaml-ocamlbuild-devel
BuildRequires:  ocaml-compiler-libs
BuildRequires:  ocaml-ocamldoc
BuildRequires:  m4, ncurses-devel
BuildRequires:  gawk
BuildRequires:  make
Requires:       ocaml

%global __ocaml_requires_opts -i Asttypes -i Parsetree

%description
Objective CAML package manager and build helper.

%package        devel
Summary:        Development files for %{name}
Requires:       %{name} = %{version}-%{release}

%description    devel
The %{name}-devel package contains libraries and header files for
developing applications that use %{name}.

%package        doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{EVR}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%prep
%autosetup -p1 -n findlib-%{version}

%build
ocamlc -version
ocamlc -where
(cd tools/extract_args && make)
tools/extract_args/extract_args -o src/findlib/ocaml_args.ml ocamlc ocamlcp ocamlmktop ocamlopt ocamldep ocamldoc ||:
cat src/findlib/ocaml_args.ml
./configure -config %{_sysconfdir}/ocamlfind.conf \
  -bindir %{_bindir} \
  -sitelib `ocamlc -where` \
  -mandir %{_mandir} \
  -with-toolbox
make all
%ifarch %{ocaml_native_compiler}
%ifnarch sw_64
make opt
%endif
%endif
rm doc/guide-html/TIMESTAMP

%install
mkdir -p $RPM_BUILD_ROOT%{_bindir}
mkdir -p $RPM_BUILD_ROOT%{_mandir}/man{1,5}
make install \
     prefix=$RPM_BUILD_ROOT \
     OCAMLFIND_BIN=%{_bindir} \
     OCAMLFIND_MAN=%{_mandir}

%files
%doc LICENSE
%config(noreplace) %{_sysconfdir}/ocamlfind.conf
%{_bindir}/*
%{_mandir}/man1/*
%{_mandir}/man5/*
%{_libdir}/ocaml/*/META
%{_libdir}/ocaml/topfind
%{_libdir}/ocaml/findlib
%ifarch %{ocaml_native_compiler}
%exclude %{_libdir}/ocaml/findlib/*.a
%exclude %{_libdir}/ocaml/findlib/*.cmxa
%endif
%exclude %{_libdir}/ocaml/findlib/*.mli
%exclude %{_libdir}/ocaml/findlib/Makefile.config
%exclude %{_libdir}/ocaml/findlib/make_wizard
%exclude %{_libdir}/ocaml/findlib/make_wizard.pattern

%files devel
%doc LICENSE
%doc doc/README doc/guide-html
%ifarch %{ocaml_native_compiler}
%{_libdir}/ocaml/findlib/*.a
%{_libdir}/ocaml/findlib/*.cmxa
%endif
%{_libdir}/ocaml/findlib/*.mli
%{_libdir}/ocaml/findlib/Makefile.config

%files doc
%doc doc/README

%changelog
* Tue Mar 11 2025 xunian <xunian@nfschina.com> - 1.9.6-2
- Add sw_64 support

* Sat Mar 18 2023 Yuanhong Peng <yummypeng@linux.alibaba.com> - 1.9.6-1
- Init from upstream
